<?php

namespace backend\modules\reports\controllers;

use Yii;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use yii\data\ArrayDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii2tech\spreadsheet\Spreadsheet;
use yii\filters\VerbFilter;
use yii\db\Query;
use Mpdf\Mpdf;
use backend\modules\reports\models\GstReport2;

class GstReport2Controller extends \yii\web\Controller
{
    public function actionIndex($date=null)
    {   
        $model=new GstReport2();
        $query = GstReport2::find();
        if(Yii::$app->request->get()) {
            $model->load(Yii::$app->request->queryParams);
            if($model->till_date)
            {
                $date=$model->till_date . "-01";
            }elseif ($date) {
                $date=$date."-01";
            }    
            $query=Yii::$app->db->createCommand("CALL gstr_2(:params_1)")->bindValue(':params_1',$date)->queryAll();
        }else{
            $date=date('Y-m-d');
            $query=Yii::$app->db->createCommand("CALL gstr_2(:params_1)")->bindValue(':params_1',$date)->queryAll();
        }
        $dataProvider = new ArrayDataProvider([
            'allModels'=>$query,
        ]);
        // print_r($dataProvider->models);die();
        $taxable_value=0;
        $tax_amount=0;
        $total_transaction=0;
        $pendings=0;
        foreach($dataProvider->models as $key => $value) {
            if($value['pending_amount']==$value['total']) $pendings++;
            $total_transaction++;
            $taxable_value=$taxable_value+$value['subtotal'];
            $tax_amount=$tax_amount+$value['igst']+$value['cgst']+$value['sgst'];

        }
        return $this->render('index', [
            'date' =>$date,
            'model' => $model,
            'taxable_value'=>$taxable_value,
            'tax_amount'=>$tax_amount,
            'total_transaction'=>$total_transaction,
            'pendings'=>$pendings,
        ]);            
    }
    public function actionDetails($till_date=null)
    {  
        $model=new GstReport2();
        $query = GstReport2::find();
        $date=date('Y-m-d');
        $query=Yii::$app->db->createCommand("CALL gstr_2(:params_1)")->bindValue(':params_1',$date)->queryAll();
        if(Yii::$app->request->get()) {
            $model->load(Yii::$app->request->queryParams);
            if($model->till_date){
            $date=$model->till_date . "-01";
            $query=Yii::$app->db->createCommand("CALL gstr_2(:params_1)")->bindValue(':params_1',$date)->queryAll();
            }elseif ($till_date) {
                $date=$till_date . "-01";
                $query=Yii::$app->db->createCommand("CALL gstr_2(:params_1)")->bindValue(':params_1',$date)->queryAll();
            }
    }
    $dataProvider = new ArrayDataProvider([
        'allModels'=>$query,
    ]);
    return $this->render('details', [
        'model' => $model,
        'till_date'=>$till_date,
        'dataProvider' => $dataProvider,
    ]);
    }
}
?>