<?php

namespace backend\modules\reports\controllers;

use backend\modules\master\models\Product;
use backend\modules\master\models\PurchaseOrderProduct;
use backend\modules\master\models\Vendor;
use common\models\User;
use Mpdf\Mpdf;
use Yii;
use yii\helpers\ArrayHelper;
use backend\modules\reports\models\PurchaseOrderReport;
use yii\data\ActiveDataProvider;
use PHPExcel;
use PHPExcel_IOFactory;
class PurchaseOrderReportController extends \yii\web\Controller
{
    public function actionIndex($print=null,$excel=null)
    {
        $model = new PurchaseOrderReport();
        $query = PurchaseOrderReport::find();

        if(Yii::$app->request->get()) {
         $model->load(Yii::$app->request->queryParams);
         $query->andFilterWhere(['vendor_name'=> $model->v_name])
               ->andFilterWhere(['setting_type'=> $model->setting_type])
               ->andFilterWhere(['between','Date', $model->from_date,$model->to_date])
               ->andFilterWhere(['user_id'=>$model->user_name]);
         if($model->product_name)
         {
             $find_purchase = PurchaseOrderProduct::find()->select(['purchase_order_id'])->where(['product_id'=>$model->product_name])->groupBy(['purchase_order_id'])->all();
             $view = ArrayHelper::map($find_purchase,'purchase_order_id','purchase_order_id');
             $query->andFilterWhere(['in','purchase_order_id',$view]);
         }
             if($model->status == 2){
                 $query->andFilterWhere(['gr_status'=> $model->status]);
             }else{
                 $query->andFilterWhere(['<','gr_status',2]);
             }

        }

        $dataProvider = new ActiveDataProvider([
            'query'=>$query,

        ]);
        if($print=='true')
        {
            $for = 'print';
            $this->actionExportpdf($dataProvider,$model,$for);
        }
        if($print=='false')
        {
            $for = 'pdf';
            $this->actionExportpdf($dataProvider,$model,$for);
        }
        if($excel !=null){
            $this->actionExcelReport($dataProvider);
        }

        return $this->render('index',[
            'dataProvider'=>$dataProvider,
            'model'=> $model,
        ]);
    }
    public function actionProductdetails($searchTerm=null)
    {
        if(!$searchTerm)
            $product=Product::find()->limit(10)->all();
        else
            $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }
    public function actionVendordetails($searchTerm=null)
    {
        if(!$searchTerm)
            $product=Vendor::find()->limit(10)->all();
        else
            $product=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'business_name', 'business_name');
        return json_encode($productlist);
    }
    public function actionUserdetails($searchTerm=null)
    {
        if(!$searchTerm)
            $product=User::find()->limit(10)->all();
        else
            $product=User::find()->where(["like","username",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'username');
        return json_encode($productlist);
    }
    public function actionExportPdf($data=null,$model=null,$for=null)
    {
        if($for=='print')
        {
            $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/purchase-order-report/exportpdf', [
                'dataProvider' => $data,
                'model'=>$model,

            ]));
            $mpdf->Output('Purchase_Order_Report.pdf', 'I');
        }
        else
        {
            $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/purchase-order-report/exportpdf', [
                'dataProvider' => $data,
                'model'=>$model,

            ]));
            $mpdf->Output('Purchase_Order_Report.pdf', 'D');
        }
    }

    public function actionExcelReport($data=null)
    {
        if ($data != null){
	  // print_r($data);
	   // die();
            $dataProvider = $data;
        }else{

            $query = PurchaseOrderReport::find();

            $dataProvider = new ActiveDataProvider([
              'query'=> $query,
                'pagination'=>false,
            ]);

        }

        $phpExcel = new PHPExcel;
        $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
        // $phpExcel->getDefaultStyle()->getFont()->setSize(14);
        // $phpExcel ->getProperties()->setTitle("Vendor list");
        $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
        $writer = PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
        $sheet = $phpExcel ->getActiveSheet();
        // $sheet->setTitle('My product list');
        $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
        $sheet ->getCell('A2')->setValue('');
        $sheet ->getCell('A3')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
        $sheet ->getCell('A4')->setValue('BHUBANESWAR, Odisha');
        $sheet ->getCell('A5')->setValue('');
        $sheet ->getCell('A6')->setValue('Purchase Report');
        // Making headers text bold and larger
        $sheet->getStyle('A1:P1')->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('A2:P2')->getFont()->setSize(11);
        $sheet->getStyle('A3:P3')->getFont()->setSize(11);
        $sheet->getStyle('A4:P4')->getFont()->setSize(11);
        $sheet->getStyle('A5:P5')->getFont()->setSize(11);
        $sheet->getStyle('A6:P6')->getFont()->setSize(11);

        $sheet->getColumnDimension('A')->setWidth(20);
        $sheet->getColumnDimension('B')->setWidth(40);
        $sheet->getColumnDimension('C')->setWidth(9);
        $sheet->getColumnDimension('D')->setWidth(20);
        $sheet->getColumnDimension('E')->setWidth(20);
        $sheet->getColumnDimension('F')->setWidth(9);
        $sheet->getColumnDimension('G')->setWidth(10);
        $sheet->getColumnDimension('H')->setWidth(15);
        $sheet->getColumnDimension('I')->setWidth(15);
        $sheet->getColumnDimension('J')->setWidth(15);
        $sheet->getColumnDimension('K')->setWidth(15);
        $sheet->getColumnDimension('L')->setWidth(20);
        $sheet->getColumnDimension('M')->setWidth(15);
        $sheet->getColumnDimension('N')->setWidth(12);
        $sheet->getColumnDimension('O')->setWidth(20);
        $sheet->getColumnDimension('P')->setWidth(40);

        $sheet->mergeCells('A1:P1');
        $sheet->mergeCells('A2:P2');
        $sheet->mergeCells('A3:P3');
        $sheet->mergeCells('A4:P4');
        $sheet->mergeCells('A5:P5');
        $sheet->mergeCells('A6:P6');

        $sheet->setCellValue('A8',  'Date');
        $sheet->setCellValue('B8',  'Vendor Name');
        $sheet->setCellValue('C8',  'VCH No#');
        $sheet->setCellValue('D8',  'Vendor Bill#');
        $sheet->setCellValue('E8',  'TIN/Purchase Tax No');
        $sheet->setCellValue('F8',  'Qty');
        $sheet->setCellValue('G8',  'Rate');
        $sheet->setCellValue('H8',  'Gross Total');
        $sheet->setCellValue('I8',  'Tax Amount');
        $sheet->setCellValue('J8',  'Other Cahrges');
        $sheet->setCellValue('K8',  'Bill Total');
        $sheet->setCellValue('L8',  'Category');
        $sheet->setCellValue('M8',  'Paid Amount');
        $sheet->setCellValue('N8',  'Paid Date');
        $sheet->setCellValue('O8',  'Cheque Ref.');
        $sheet->setCellValue('P8',  'User');
$sheet->setCellValue('Q8',  'CGST Amount');
        $sheet->setCellValue('R8',  'CGST %');
        $sheet->setCellValue('S8',  'SGST Amount');
        $sheet->setCellValue('T8',  'SGST %');
        $sheet->setCellValue('U8',  'IGST Amount');
        $sheet->setCellValue('V8',  'IGST %');
        $row=9;
        $total_qty=0;
        $total_gross=0;$total_tax=0;$total_bill=0;$total_paid=0;$total_other=0;
        if (!empty($dataProvider->getModels())) {
            foreach ($dataProvider->getModels() as $key => $val) {
                $total_qty+=$val->qty;
                $total_gross+=$val->gross_total;
                $total_tax+=$val->tax_amount;
                $total_bill+=$val->bill_total;
                $total_paid+=$val->paid_amount;
                $total_other+=$val->other_charges;
            }

        }

        foreach ($dataProvider->models as $model)
        {

            $sheet->getStyle('B'.$row)->getAlignment()->setWrapText(true);
            $sheet->getStyle('P'.$row)->getAlignment()->setWrapText(true);

            $user = User::find()->where(['id'=>$model->user_id])->one();

             $sheet->setCellValue('A' . $row,  Yii::$app->formatter->asDate($model->Date,'long'));
             $sheet->setCellValue('B' . $row,  (string)$model->vendor_name);
             $sheet->setCellValue('C' . $row,  $model->vch_no);
             $sheet->setCellValue('D' . $row,  $model->vendor_bill_no);
             $sheet->setCellValue('E' . $row,  $model->gst_no);
             $sheet->setCellValue('F' . $row,  (string)$model->qty);
            $sheet->setCellValue('G' . $row,  $model->rate);
            $sheet->setCellValue('H' . $row,  (string)$model->gross_total);
              $sheet->setCellValue('I' . $row,  $model->tax_amount);
             $sheet->setCellValue('J' . $row,  $model->other_charges);
            $sheet->setCellValue('K' . $row,  $model->bill_total);
            $sheet->setCellValue('L' . $row,  $model->category);
             $sheet->setCellValue('M' . $row,  $model->paid_amount);
              $sheet->setCellValue('N' . $row,  $model->bill_date);
              $sheet->setCellValue('O' . $row,   $model->cheque_ref);
              if($user)
                 $sheet->setCellValue('P' . $row,  (string)$user->username);
              else
                 $sheet->setCellValue('P' . $row,  '');
$cgstp=(($model->cgst_amount/$model->gross_total)*100);
            $sgstp = (($model->sgst_amount / $model->gross_total) * 100);
            $igstp = (($model->igst_amount / $model->gross_total) * 100);
$sheet->setCellValue('Q' . $row,  $model->cgst_amount!=null?$model->cgst_amount:"0.00");
            

                $sheet->setCellValue('R' . $row,  (string)$cgstp.'%');

         
                $sheet->setCellValue('S' . $row,  $model-> sgst_amount != null ? $model->sgst_amount : "0.00");
           
                $sheet->setCellValue('T' . $row,  (float)$sgstp.'%');
            
                $sheet->setCellValue('U' . $row,  $model->igst_amount != null ? $model->igst_amount : "0.00");
           
                $sheet->setCellValue('V' . $row,  (float)$igstp.'%'); 
            $row++;
        }
        $sheet->setCellValue('F' . $row,(string)$total_qty);
        $sheet->setCellValue('H' . $row, Yii::$app->formatter->asCurrency(round($total_gross,2),'INR'));
        $sheet->setCellValue('I' . $row, Yii::$app->formatter->asCurrency(round($total_tax,2),'INR'));
        $sheet->setCellValue('J' . $row, Yii::$app->formatter->asCurrency(round($total_other,2),'INR'));
        $sheet->setCellValue('K' . $row, Yii::$app->formatter->asCurrency(round($total_bill,2),'INR'));
        $sheet->setCellValue('M' . $row, Yii::$app->formatter->asCurrency(round($total_paid,2),'INR'));

        ob_clean();
        ob_start();

        header('Content-type: application/vnd.ms-excel'); // It will be called file.xls
        header('Content-Disposition: attachment; filename="Purchase-order-report.xlsx"'); // Write file to the browser

        $writer->save('php://output');
        ob_flush();
        exit();






    }





}
