<?php

namespace backend\modules\reports\controllers;

use Yii;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;
use backend\modules\reports\models\PurchaseReportByProduct;
use backend\modules\reports\models\PurchaseReportByProductSearch;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Product;
 use yii2tech\spreadsheet\Spreadsheet;
 use backend\modules\master\models\PurchaseOrder;
// use PhpOffice\PhpSpreadsheet\Spreadsheet;
// use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use yii\helpers\Url;
use kartik\export\ExportMenu;
use yii\grid\GridView;
use backend\modules\users\models\PurchaseBill;

class PurchaseReportByProductController extends \yii\web\Controller
{
    public function actionIndex($print=null,$excel=null,$detailprint=null)
    {
        $model = new PurchaseReportByProduct();
        $searchModel = new PurchaseReportByProductSearch();
      $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $query=PurchaseReportByProduct::find();


        if($model->load(Yii::$app->request->get())){

        $query->andFilterWhere(['like','VendorName',$model->vendor])
                   ->andFilterWhere(['like', 'Category', $model->vendor_catagory])
                   ->andFilterWhere(['like', 'updated_by', $model->created_by_user])
                   ->andFilterWhere(['like', 'Product', $model->searchproduct])
                   // ->andFilterWhere(['like', 'executive', $model->executive_name])
                   ->andFilterWhere(['between', 'Date', $model->from_date,$model->to_date]); 

            if($model->purchase_type){
                if($model->purchase_type=='Expense'){
                    
                $query->andFilterWhere(['>', 'gr_status', 1]);
                }
                elseif($model->purchase_type=='Purchase Order') {
                    $query->andFilterWhere(['<=', 'gr_status',1 ]);
                }
                
            } 
            if($model->setting){
                if($model->setting=='Tax Bill'){
                    
                $query->andFilterWhere(['>', 'gr_status', 1]);
                }
                elseif($model->setting=='Purchase Order') {
                    $query->andFilterWhere(['<=', 'gr_status',1 ]);
                }
                
            }    
      }


        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            // 'pagination' => false,
            
        ]);
        if($print!=null)
        {
          
            $for = 'print';
            $this->actionExportpdf($dataProvider,$model,$for);
        }
        
        if($detailprint!=null)
        {
          $for = 'detailprint';
          $this->actionExportpdf($dataProvider,$model,$for);
        }
        if($excel!=null)
        {
	    $dataProvider->pagination = false;
            $this->actionExcelreport($dataProvider,$model);
        }
       
        return $this->render('index', [
            'model' => $model,  
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionVendordetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $customer=Vendor::find()->limit(10)->all();
        else
        $customer=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
        return json_encode($customerlist);
    }
    public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'product_name', 'product_name');
        return json_encode($productlist);
    }

    public function actionExportpdf($data=null,$model=null,$for=null)
    {
	ini_set("pcre.backtrack_limit", "3000000");
        if($for=='print')
        {
            $data->pagination = false;
              $mpdf = new mPDF;
              $mpdf->showImageErrors = true;
              $mpdf->WriteHTML($this->renderPartial('/purchase-report-by-product/exportpdf', [
                  'dataProvider' => $data,
                  'model'=>$model,

                ]));

            $mpdf->Output('Purchase-report-by-product.pdf', 'D');
        }
        else
        {
            $data->pagination = false;
              $mpdf = new mPDF;
              $mpdf->showImageErrors = true;
              $mpdf->WriteHTML($this->renderPartial('/purchase-report-by-product/exportpdf', [
                  'dataProvider' => $data,
                  'model'=>$model,

              ]));
              $mpdf->Output('Purchase-report-by-product.pdf', 'I');
        }
    }


    public function actionExcelreport($data=null,$mod=null)
    {  
        
        if($data!=null){
             $dataProvider = $data;
	     $dataProvider->pagination = false; 
        }
        else
        {
          $dataProvider = new ActiveDataProvider([
            'query' => PurchaseReportByProduct::find()->orderBy(['Date' => SORT_DESC]),
        ]);
	$dataProvider->pagination = false;
        }

      

      $phpExcel = new \PHPExcel;
     // $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
      // $phpExcel->getDefaultStyle()->getFont()->setSize(14);
      // $phpExcel ->getProperties()->setTitle("Vendor list");
      $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();
       
      // $sheet->setTitle('My product list');
      $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
      $sheet ->getCell('A2')->setValue('');
      $sheet ->getCell('A3')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
      $sheet ->getCell('A4')->setValue('BHUBANESWAR, Odisha');
      $sheet ->getCell('A5')->setValue('');
      $sheet ->getCell('A6')->setValue('Purchase Report');
      // Making headers text bold and larger
      $sheet->getStyle('A1:S1')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A2:S2')->getFont()->setSize(11);
      $sheet->getStyle('A3:S3')->getFont()->setSize(11);
      $sheet->getStyle('A4:S4')->getFont()->setSize(11);
      $sheet->getStyle('A5:S5')->getFont()->setSize(11);
      $sheet->getStyle('A6:S6')->getFont()->setBold(true)->setSize(11);

      $sheet->getColumnDimension('A')->setWidth(20);
      $sheet->getColumnDimension('B')->setWidth(40);
      $sheet->getColumnDimension('C')->setWidth(20);
      $sheet->getColumnDimension('D')->setWidth(20);
      $sheet->getColumnDimension('E')->setWidth(20);
      $sheet->getColumnDimension('F')->setWidth(40);
      $sheet->getColumnDimension('G')->setWidth(5);
      $sheet->getColumnDimension('H')->setWidth(10);
      $sheet->getColumnDimension('I')->setWidth(5);
      $sheet->getColumnDimension('J')->setWidth(10);
      $sheet->getColumnDimension('K')->setWidth(12);
      $sheet->getColumnDimension('L')->setWidth(12);
      $sheet->getColumnDimension('M')->setWidth(12);
      $sheet->getColumnDimension('N')->setWidth(20);
      $sheet->getColumnDimension('O')->setWidth(20);
      $sheet->getColumnDimension('P')->setWidth(10);

      $sheet->mergeCells('A1:S1');
      $sheet->mergeCells('A2:S2');
      $sheet->mergeCells('A3:S3');
      $sheet->mergeCells('A4:S4');
      $sheet->mergeCells('A5:S5');
      $sheet->mergeCells('A6:S6');

      if($mod->from_date!=null)
      {
        $sheet->setCellValue('A7', date('d-m-Y', strtotime($mod->from_date)).' to '.date('d-m-Y', strtotime($mod->to_date)));
      }
      else{
        $sheet->setCellValue('A7', '');
      }


      $sheet->setCellValue('A8',  'Date');
      $sheet->setCellValue('B8',  'Vendor Name');
      $sheet->setCellValue('C8',  'VCH No#');
      $sheet->setCellValue('D8',  'Vendor Bill#');
      $sheet->setCellValue('E8',  'TIN/Purchase Tax No');
      $sheet->setCellValue('F8',  'Product');
      $sheet->setCellValue('G8',  'Qty');
      $sheet->setCellValue('H8',  'Rate');
      $sheet->setCellValue('I8',  'Unit');
      $sheet->setCellValue('J8',  'Bill Total');
      $sheet->setCellValue('K8',  'Tax Amount');
      $sheet->setCellValue('L8',  'Other charges');
      $sheet->setCellValue('M8',  'Gross Total');
      $sheet->setCellValue('N8',  'Category');
      $sheet->setCellValue('O8',  'User');
      $sheet->setCellValue('P8',  'Branch');

        $row=9;
        $totalprice = 0;
        $totalgrossamount =0;
        $totalquantity =0;
        $totaltaxamount =0;
        $totalothercharges = 0;

        foreach ($dataProvider->models as $model) {

        $tcs_percentage =0;
        $product_tcs =0;
        $gtotal =0;
        $purchase = PurchaseOrder::find()->where(['id'=>$model->VChNo])->one();
        if($purchase->is_tcs==1)
        {
          $tcs_percentage = (($purchase->tcs/($purchase->total_amount-$purchase->tcs)*100));
          $product_tcs = ($model->gross_total*($tcs_percentage/100));

          $gtotal = $gtotal+($product_tcs+$model->gross_total);
        }
        else
        {
          $gtotal = $gtotal + $model->gross_total;
        }
        $totalothercharges = $totalothercharges + $product_tcs;
        $totalgrossamount = $totalgrossamount + $gtotal;
        $product_tcs = (string)$product_tcs;
        $gtotal = (string)$gtotal;







          
          $sheet->getStyle('F'.$row)->getAlignment()->setWrapText(true);
          $sheet->getRowDimension($row)->setRowHeight(30);
         
          // 
          $price = 0;


         if($model->tax_included==1)
          {
            if($model->discount_type=='FLAT')
                if($model->ItemDiscount!='')
                 $price = $model->gross_total-($model->BillTotal-$model->ItemDiscount);
            else if ($model->discount_type=='%')
               if($model->ItemDiscount!='')
                 $price = $model->gross_total-($model->BillTotal-($model->BillTotal*($model->ItemDiscount/100)));
            else
                $price = $model->gross_total-$model->BillTotal;
          }
          else
          {
              $price = 0;
          }
          $totaltaxamount = $totaltaxamount + $price;
          $price = (string)$price;

          $totalprice = $totalprice + $model->BillTotal;
          $totalquantity = $totalquantity + $model->Qty;
        $user = User::find()->where(['id'=>$model->updated_by])->one();
	$purchase_data = PurchaseOrder::find()->where(['id'=>$model->VChNo])->one();
	$bill = PurchaseBill::find()->where(['purchase_order_id'=>$purchase_data->id])->one();

        $sheet->setCellValue('A' . $row,  date('F j Y', strtotime($model->Date)));
        $sheet->setCellValue('B' . $row,  $model->VendorName);
        $sheet->setCellValue('C' . $row,  (string)$purchase_data->po_no_final);    
	if($bill)
	{
		$sheet->setCellValue('D' . $row, (string)$bill->vendor_bill_no);
	}
	else
	{
		 $sheet->setCellValue('D' . $row,  '');
	}
        $sheet->setCellValue('E' . $row,  $model->TINPurchaseNo); 
        $sheet->setCellValue('F' . $row,  $model->Product); 
        $sheet->setCellValue('G' . $row,  $model->Qty); 
        $sheet->setCellValue('H' . $row,  $model->Rate); 
        $sheet->setCellValue('I' . $row,  $model->Units); 
        $sheet->setCellValue('J' . $row,  $model->BillTotal); 
        $sheet->setCellValue('K' . $row,  $price); 
        $sheet->setCellValue('L' . $row,  $product_tcs); 
        $sheet->getStyle('L' . $row)->getNumberFormat()->setFormatCode('0.00');
        $sheet->setCellValue('M' . $row,  $gtotal); 
        $sheet->getStyle('M' . $row)->getNumberFormat()->setFormatCode('0.00');
        $sheet->setCellValue('N' . $row,  $model->Category); 
	if($user)
        {
            $sheet->setCellValue('O' . $row,   $user->username);  
        }
        else
        {
            $sheet->setCellValue('O' . $row, ''); 
        }
        $sheet->setCellValue('P' . $row,  ''); 
        $row++;   

       } 

       $sheet->setCellValue('B' . $row, 'Total(Rs)');
        $sheet->setCellValue('G' . $row,  (string)$totalquantity);
        $sheet->setCellValue('H' . $row,  '-'); 
        $sheet->setCellValue('I' . $row,  '-'); 
        $sheet->setCellValue('J' . $row,  (string)$totalprice); 
        $sheet->setCellValue('K' . $row,  (string)$totaltaxamount); 
        $sheet->setCellValue('L' . $row,  (string)$totalothercharges); 
        $sheet->setCellValue('M' . $row,  (string)$totalgrossamount); 


        $sheet->getStyle('B'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('G'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('H'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('I'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('J'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('K'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('L'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('L' . $row)->getNumberFormat()->setFormatCode('0.00');
        $sheet->getStyle('M'.$row)->getFont()->setBold(true)->setSize(11);
        $sheet->getStyle('M' . $row)->getNumberFormat()->setFormatCode('0.00');
        ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="purchase-report-by-product.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();
      }

}
