<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "customer_ledger_overview".
 *
 * @property string|null $Date
 * @property string|null $customer_type
 * @property string|null $business_name
 * @property string|null $executive
 * @property float|null $total_debit_amount
 * @property float|null $total_credit_amount
 * @property string|null $ledgerhead_id
 */
class CustomerLedgerOverview extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'customer_ledger_overview';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['Date'], 'safe'],
            [['total_debit_amount', 'total_credit_amount'], 'number'],
            [['customer_type', 'business_name', 'executive', 'ledgerhead_id'], 'string', 'max' => 254],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'Date' => 'Date',
            'customer_type' => 'Customer Type',
            'business_name' => 'Business Name',
            'executive' => 'Executive',
            'total_debit_amount' => 'Total Debit Amount',
            'total_credit_amount' => 'Total Credit Amount',
            'ledgerhead_id' => 'Ledgerhead ID',
        ];
    }
}
