<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "daily_collection_report".
 *
 * @property string|null $payment_mode
 * @property float|null $amount
 * @property string|null $date
 * @property string $payment_category
 */
class DailyCollectionReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'daily_collection_report';
    }
    public $from_date;
    public $to_date;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['amount'], 'number'],
            [['payment_mode'], 'string', 'max' => 255],
            [['date'], 'string', 'max' => 32],
            [['payment_category'], 'string', 'max' => 7],
            [['from_date','to_date'], 'safe'],
            [['from_date','to_date'],'required'],
            ['to_date', 'compare', 'compareAttribute' => 'from_date', 'operator' => '>=','message'=>'To date must be equal/greater than From date'],
        ];
    }
   

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'payment_mode' => 'Payment Mode',
            'amount' => 'Amount',
            'date' => 'Date',
            'payment_category' => 'Payment Category',
        ];
    }
}
