<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "general_ledger".
 *
 * @property string|null $Date
 * @property string|null $client_type
 * @property float|null $total_debit_amount
 * @property float|null $total_credit_amount
 * @property string|null $ledgerhead_id
 * @property int|null $group_name_id
 * @property int|null $account_type_id
 * @property string $client
 */
class GeneralLedgerReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'general_ledger';
    }
public $from_date;
public $to_date;
public $type;
public $group;
public $ledg_bal;
public $sort_by;
public $search;
public $ledger_name;


    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['Date'], 'safe'],
            [['total_debit_amount', 'total_credit_amount'], 'number'],
            [['group_name_id', 'account_type_id'], 'integer'],
            [['client_type'], 'string', 'max' => 254],
            [['ledgerhead_id'], 'string', 'max' => 255],
            [['client'], 'string', 'max' => 8],
            [['search','from_date','to_date','type','group','ledg_bal','sort_by','ledger_name'], 'string', 'max' => 255],
            ['to_date', 'compare', 'compareAttribute' => 'from_date', 'operator' => '>=','message'=>'To date must be equal/greater than From date'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'Date' => 'Date',
            'client_type' => 'Client Type',
            'total_debit_amount' => 'Total Debit Amount',
            'total_credit_amount' => 'Total Credit Amount',
            'ledgerhead_id' => 'Ledgerhead ID',
            'group_name_id' => 'Group Name ID',
            'account_type_id' => 'Account Type ID',
            'client' => 'Client',
        ];
    }
}
