<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "gstr1_creditnotes".
 *
 * @property string|null $invoice_no
 * @property string|null $gstn_no
 * @property string|null $invoice_date
 * @property string|null $credit_note_id
 * @property string|null $creditnote_date
 * @property float|null $total_value
 * @property float|null $tax_rate
 * @property float|null $taxable_value
 * @property float|null $igst_value
 * @property float|null $cgst_value
 * @property float|null $sgst_amount
 * @property string|null $point_of_supply
 */
class Gstr1Creditnotes extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'gstr1_creditnotes';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['invoice_date', 'creditnote_date'], 'safe'],
            [['total_value', 'tax_rate', 'taxable_value', 'igst_value', 'cgst_value', 'sgst_amount'], 'number'],
            [['invoice_no', 'gstn_no', 'credit_note_id', 'point_of_supply'], 'string', 'max' => 254],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'invoice_no' => 'Invoice No',
            'gstn_no' => 'Gstn No',
            'invoice_date' => 'Invoice Date',
            'credit_note_id' => 'Credit Note ID',
            'creditnote_date' => 'Creditnote Date',
            'total_value' => 'Total Value',
            'tax_rate' => 'Tax Rate',
            'taxable_value' => 'Taxable Value',
            'igst_value' => 'Igst Value',
            'cgst_value' => 'Cgst Value',
            'sgst_amount' => 'Sgst Amount',
            'point_of_supply' => 'Point Of Supply',
        ];
    }
}
