<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "purchase_pending_report".
 *
 * @property string|null $id
 * @property string|null $date
 * @property string|null $particulars
 * @property string|null $due_date
 * @property float|null $total_amount
 * @property float|null $pending_amount
 */
class PurchasePendingReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_pending_report';
    }
    public $to_date;
    public $from_date;
    public $purchase_date;
    Public $vendor_name;
    public $vch_no;
    public $purchase_orderBy;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['to_date','from_date','purchase_date'],'safe'],
            [['vendor_name','vch_no','purchase_orderBy'],'string'],
            [['date', 'due_date'], 'safe'],
            [['total_amount', 'pending_amount'], 'number'],
            [['id', 'particulars'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'date' => 'Date',
            'particulars' => 'Particulars',
            'due_date' => 'Due Date',
            'total_amount' => 'Total Amount',
            'pending_amount' => 'Pending Amount',
        ];
    }
}
