<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "vendor_aging_report".
 *
 * @property string|null $vendor_type
 * @property string|null $createdat
 * @property int|null $y
 * @property int|null $m
 * @property string|null $ledgerhead_id
 * @property float|null $first_month
 * @property float|null $second_month
 * @property float|null $third_month
 * @property float|null $fourth_month
 * @property float|null $fifth_month
 * @property float|null $sixth_month
 * @property float|null $total_debit
 * @property float|null $total_credit
 */
class VendorAgingReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $vendor_vtype;
    public $to_date;
    public $from_date;
    public $type;
    public $records;
    public $report_type;
    public static function tableName()
    {
        return 'vendor_aging_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['createdat','to_date','from_date'], 'safe'],
            [['y', 'm'], 'integer'],
            [['first_month', 'second_month', 'third_month', 'fourth_month', 'fifth_month', 'sixth_month', 'total_debit', 'total_credit'], 'number'],
            [['vendor_type','vendor_vtype','type','records','report_type'], 'string', 'max' => 254],
            [['ledgerhead_id'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'vendor_type' => 'Vendor Type',
            'createdat' => 'Createdat',
            'y' => 'Y',
            'm' => 'M',
            'ledgerhead_id' => 'Ledgerhead ID',
            'first_month' => 'First Month',
            'second_month' => 'Second Month',
            'third_month' => 'Third Month',
            'fourth_month' => 'Fourth Month',
            'fifth_month' => 'Fifth Month',
            'sixth_month' => 'Sixth Month',
            'total_debit' => 'Total Debit',
            'total_credit' => 'Total Credit',
        ];
    }
}
