<?php

use backend\modules\master\models\Category;
use yii\helpers\Html;
// use yii\grid\GridView;
use kartik\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use common\models\User;
use yii\helpers\ArrayHelper;


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Compilation Stock Report';
$this->params['breadcrumbs'][] = $this->title;
$nonzero = ['0' => 'Zero Stock', '1' => 'Non Zero Stock'];
?>
<style>
    .text-wrap {
        white-space: -moz-pre-wrap !important;
        /* Mozilla, since 1999 */
        white-space: -pre-wrap;
        /* Opera 4-6 */
        white-space: -o-pre-wrap;
        /* Opera 7 */
        white-space: pre-wrap;
        /* css-3 */
        word-wrap: break-word;
        /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap;
        /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }

    .select2-container .select2-selection--single {
        height: 42px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 39px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 39px;
    }

    .add_product .select2-selection__rendered {
        width: 220px !important;
    }

    th a {
        color: #495057;
    }

    th a:hover {
        color: #495057;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }

    .YourCustomTableClass table thead {
        background-color: #16aaff;
    }
</style>
<?php if (Yii::$app->session->hasFlash('success')) { ?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success'); ?></strong>
    </div>
<?php } ?>
<?php if (Yii::$app->session->hasFlash('error')) : ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Compilation Stock Report</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <div class="djsec-text-right dj-print-sec">




                                                <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                    <a href="<?= Url::current() ?>&excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } else { ?>
                                                    <a href="<?= Url::current() ?>?excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } ?>


                                            </div>
                                        </div>

                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-11">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-1">
                    <a class="search_field_buttons" href="<?= Url::base() . '/reports/compilation-stock-report/index' ?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                </div>
            </div>

            <?php $form = ActiveForm::begin(['action' => ['index'], 'method' => 'get'], ['options' => ['class' => "dj-sale-form collapse"]]); ?>
            <div class="dj-sale-form collapse" id="search-report">
                <div class="form-row">
                    <div class="col-md-3">
                        <div class="position-relative form-group">
                            <label for="notes">Product</label>
                            <?php $item = ArrayHelper::map(Product::find()->all(), 'id', 'product_name'); ?>
                            <!-- <input name="amount" id="amount" type="date" class="form-control"> -->

                            <?= $form->field($model, 'product_name')->dropDownList($item, [
                                'class' => 'form-control products-from', 'prompt' => '--Select--'
                            ])->label(false); ?>
                        </div>
                    </div>
                    <div class="col-md-3">
                        <div class="position-relative form-group">
                            <label for="notes">Product Category</label>
                            <?php $items = ArrayHelper::map(Category::find()->all(), 'name', 'name'); ?>
                            <!-- <input name="amount" id="amount" type="date" class="form-control"> -->

                            <?= $form->field($model, 'product_category')->dropDownList($items, [
                                'class' => 'form-control category', 'prompt' => '--Select--'
                            ])->label(false); ?>
                        </div>
                    </div>
                    <div class="col-md-3">
                        <div class="position-relative form-group">
                            <label for="notes">Vendor Name</label>
                            <?php $items = ArrayHelper::map(Vendor::find()->all(), 'id', 'business_name'); ?>
                            <!-- <input name="amount" id="amount" type="date" class="form-control"> -->

                            <?= $form->field($model, 'vendor_name')->dropDownList($items, [
                                'class' => 'form-control vendor', 'prompt' => '--Select--'
                            ])->label(false); ?>
                        </div>
                    </div>
                </div>
            </div>
            <div class="form-row">

                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">From</label>
                        <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                        <?= $form->field($model, 'from_date')->textInput(['maxlength' => true, 'class' => "form-control", 'type' => 'date'])->label(false) ?>

                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">To</label>
                        <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                        <?= $form->field($model, 'to_date')->textInput(['maxlength' => true, 'class' => "form-control", 'type' => 'date'])->label(false) ?>

                    </div>
                </div>
                <div class="col-md-2 dj-btn-align">
                    <button class="btn btn-info btn-rounded dj-search"><i class="fa fa-search"></i> Search</button>
                </div>
            </div>
            

            <!-- <div class="form-row">
                <div class="col-md-2 dj-btn-align">
                    <button class="btn btn-info btn-rounded dj-search"><i class="fa fa-search"></i> Search</button>
                </div>
            </div> -->
            <?php ActiveForm::end(); ?>
        </div>

    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">


            <div class="col-md-12">
                <h4 style="text-align: center">Compilation Stock Report</h4>


                <p style="text-align: center"><strong>As On: <?php echo date('d/m/Y') ?></strong></p>

            </div>
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'showFooter' => true,
                'summary' => '',
                'beforeHeader' => [
                    [
                        'columns' => [
                            ['content' => 'Item Details', 'options' => ['colspan' => 3, 'class' => 'text-center warning']],
                            ['content' => 'Opening Balance', 'options' => ['colspan' => 1, 'class' => 'text-center warning']],
                            ['content' => 'Inwards', 'options' => ['colspan' => 1, 'class' => 'text-center warning']],
                            ['content' => 'Outwards', 'options' => ['colspan' => 1, 'class' => 'text-center warning']],
                            ['content' => 'Closing Balance', 'options' => ['colspan' => 3, 'class' => 'text-center warning']],
                        ],
                        'options' => ['class' => 'skip-export'] // remove this row from export
                    ]
                ],
                'footerRowOptions' => ['style' => 'font-weight:bold;'],
                "id" => "grid",
                'columns' => [
                    [
                        'label' => 'Name',
                        'format' => 'raw',
                        'value' => function ($data) {
                            // print_r($data);die();
                            // return $data['product_name'];
                            $productname = Product::find()->where(['id' => $data['product_id']])->one();
                            if($productname)
                            return  Html::a(Html::encode($productname->product_name), Url::base() . '/reports/compilation-stock-report/monthly-summary?prod_id=' . $data['product_id']);
                        }
                    ],
                    [
                        'label' => 'Selling Price',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['selling_price'];
                        }
                    ],
                    [
                        'label' => 'Vendor Name',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['vendor_name'];
                        }
                    ],
                    [
                        'label' => 'Quantity',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['opening_balance'] == null ? 0 : $data['opening_balance'];
                        }
                    ],
                    [
                        'label' => 'Quantity',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['inward'];
                        }
                    ],
                    [
                        'label' => 'Quantity',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['outward'];
                        }
                    ],

                    [
                        'label' => 'Quantity',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['closing']!=null?$data['closing']:0;
                        }
                    ],
                    [
                        'label' => 'Avg. Price',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['avg_price'];
                        }
                    ],
                    [
                        'label' => 'Amount',
                        'value' => function ($data) {
                            // print_r($data);die();
                            return $data['amount'];
                        }
                    ],
                ],
            ]); ?>
        </div>
    </div>
</div>



<?php ob_start(); ?>
<script type="text/javascript">
    $(function() {
        $('#advance-search').click(function() {
            $('#search-report').toggle();
        });
        $('.category').select2();
        $('.products-from').select2();
        $('.vendor').select2();

        $('.findproduct').select2({
            ajax: {
                url: "productdetails",
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function(params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function(response) {

                    return {
                        results: $.map(response, function(i, item) {

                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };
                },
                cache: true
            }
        });



    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>
