<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use common\models\User;
use master\models\HSNCode;

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Inward Supplies';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
input[type="month"]::-webkit-calendar-picker-indicator {
    background: none;
    bottom: 0;
    color: transparent;
    cursor: pointer;
    height: auto;
    left: 0;
    position: absolute;
    right: 0;
    top: 0;
    width: auto;
}
    .text-wrap{
        white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
        white-space: -pre-wrap;      /* Opera 4-6 */
        white-space: -o-pre-wrap;    /* Opera 7 */
        white-space: pre-wrap;       /* css-3 */
        word-wrap: break-word;       /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }
    .select2-container .select2-selection--single {
        height: 42px !important;
    }
    .select2-container--default .select2-selection--single .select2-selection__rendered
    {
        line-height: 39px;
    }
    .select2-container--default .select2-selection--single .select2-selection__arrow
    {
        height: 39px;
    }
    .add_product .select2-selection__rendered {
        width: 220px !important;
    }
    th a{
        color:#495057;
    }
    th a:hover{
        color:#495057;
    }
    body{
        font-family:Arial, Helvetica, sans-serif;
        font-size:13px;
    }
    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }
    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }
    .right{
        text-align:right;
    }
    
</style>
<?php
 // print_r($dataProvider->models);die();
    $qty=0;
    $price=0;
    $discount=0;
    $taxable_value=0;
    $igst=0;
    $cgst=0;
    $sgst=0;
        foreach($dataProvider->models as $data)
        {
    $qty+=$data->qty;   
    $price+=$data->price; 
    //    $discount+=$data->discount; 
    if($data->discount_type=='%'){
        $discount+=($data->qty*$data->price)*($data->discount/100);
        $taxable_value+=($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100));
        // $igst+=$data->amount-($data->qty*$data->price)-($data->qty*$data->price*0.01);
        if($data->point_of_supply==21){
            $sgst+=($data->amount-(($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100))))/2;

        }else{
        $igst+=$data->amount-(($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100)));

        }

    }elseif ($data->discount_type=='FLAT') {
        $discount+=$data->discount;
        $taxable_value+=($data->price-$data->discount)*$data->qty;
        if($data->point_of_supply==21){
    $sgst+=$data->amount-($data->price*$data->qty-$data->discount)/2;

        }else{
    $igst+=$data->amount-($data->price*$data->qty-$data->discount);

        }
    }
    //    $igst+=$data->amount-($data->price*$data->qty-$data->discount);
    //    $cgst+=$data->amount-($data->price*$data->qty-$data->discount)/2;
    //    $sgst+=$data->amount-($data->price*$data->qty-$data->discount)/2;
    }
?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">GST Inward Detailed Report</div>
                                        </div>
                                        <div class="col-md-1 widget-content-right">
                                             <a  class="search_field_buttons"  href="<?=Url::base().'/reports/inward-supplies-details/index?from_date='.Yii::$app->session->get('from')."&to_date=".Yii::$app->session->get('to')?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                         </div>
                                        </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-6">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-6">
                <div class="widget-content-right">
                                            <div class="djsec-text-right dj-print-sec">

                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                    <a href="<?=Url::current()?>&excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>Excel</button></a>
                                                <?php } ?>
                                                <a href="<?=Url::base().'/reports/gst-report/gstr2?from_date='.Yii::$app->session->get('from')."&to_date=".Yii::$app->session->get('to')?>" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="" aria-hidden="true"></i> Back</button></a>
                                            </div>
                                        </div>
            </div>
            </div>
            <div class="dj-sale-form collapse" id="search-report">
                <?php $form = ActiveForm::begin(['method' => 'get','action'=>'index']); ?>
                <form>
                    <div class="form-row">
                    <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Expense</label>
                                <?= $form->field($model, 'expense')->dropDownList(['' => '--Select--','Expense' => 'Expense'])->label(false); ?>
                                
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Receiver GST No</label>
                                <?= $form->field($model, 'sender_gst_id')->textInput(['maxlength' => true,'class'=>"form-control "])->label(false) ?>
                                
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">-HSN/SAC Code-</label>
                                <?= $form->field($model, 'hsn_sac_code') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control hsn",])->label(false)?>                                
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">-Bill Types-</label>
                                <?=$form->field($model, 'bill_type')->dropDownList(['B2B'=>'B2B','B2C'=>'B2C','EXPORT'=>'EXPORT','ADV PAYMENT'=>'ADV PAYMENT'], ['prompt' => '--Select--', 'class' => "select_class form-control", 'maxlength' => true])->label(false)?>
                                
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Supply Types</label>
                                <?=$form->field($model, 'supply_type')->dropDownList(['Inter-state'=>'Inter-state','Intra-state'=>'Intra-state','Export'=>'Export'], ['prompt' => '--Select--', 'class' => "select_class form-control", 'maxlength' => true])->label(false)?>
                                
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Reverse Charges</label>
                                <?= $form->field($model, 'supply_attracts')->dropDownList(['' => '--Select--','YES' => 'YES','NO' => 'NO'])->label(false); ?>
                                
                            </div>
                        </div>
                        <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Recipient Location</label>
                                                    
                                                    <?= $form->field($model, 'location')->textInput(['class'=>"form-control"])->label(false) ?>
                                                   
                                                </div>
                                            </div>
                                            
                        <div class="col-md-3">
                                        <div class="position-relative form-group add_product">
                                            <label for="date">Product</label>
                                                <?php if($model->product_name!=''){?>

                                            <?php $product=Product::find()->where(['id'=>$model->product_name])->one()?>
                                            <?=$form->field($model, 'product_name')->dropDownList([$model->product_name=>$product->product_name], ['options' => [$model->product_name => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "find_product form-control", 'maxlength' => true])->label(false)?>

                                            <?php }else {?>
                                                        
                                            <?=$form->field($model, 'product_name')->dropDownList([], ['prompt' => '--Select--', 'class' => "find_product form-control", 'maxlength' => true])->label(false)?>             
                                            <?php } ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Customers</label>
                                                   <?php if($model->vendor_id!=''){?>

                                                    <?php $customer=Vendor::find()->where(['id'=>$model->vendor_id])->one()?>
                                                   <?=$form->field($model, 'vendor_id')->dropDownList([$model->vendor_id=>$customer->business_name], ['options' => [$model->vendor_id => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "customer form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?= $form->field($model, 'vendor_id') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control customer",])->label(false)?>            
                                                   <?php } ?>



                                                    
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Time Frame</label>
                                                    <?php if($from_date && $to_date){?>

                                                   <?= $form->field($model, 'time_frame')
                                                                       ->dropDownList(['Today'=>'Today', 
                                                                                    'Current Week'=>'Current Week',
                                                                                    'Current Month'=>'Current Month',      
                                                                                    'Current Year'=>'Current Year',
                                                                                    'Custom'=>'Custom',
                                                                                   ],['options' => ['Custom' => ['Selected'=>'selected']],'prompt'=>'--Select--','class'=>'form-control time_frame select_class'])->label(false) ?>
                                                <?php  }else{ ?>
                                                    <?= $form->field($model, 'time_frame')
                                                                       ->dropDownList(['Today'=>'Today', 
                                                                                    'Current Week'=>'Current Week',
                                                                                    'Current Month'=>'Current Month',      
                                                                                    'Current Year'=>'Current Year',
                                                                                    'Custom'=>'Custom',
                                                                                   ],['prompt'=>'--Select--','class'=>'form-control time_frame select_class']
                                                                                   )->label(false) ?>
                                            <?php }?>

                                                </div>
                                            </div>
                                            <?php if($from_date && $to_date){?>
                                            <div class="col-md-3 from_date">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from')->textInput(['value'=>$from_date,'type'=>'date','class'=>"form-control from_date_val"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3 to_date">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to')->textInput(['value'=>$to_date,'type'=>'date','class'=>"form-control to_date_val"])->label(false) ?>
                                                </div>
                                            </div>
                                            <?php }else{ ?>
                                                <div class="col-md-3 from_date">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from')->textInput(['type'=>'date','class'=>"form-control from_date_val"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3 to_date">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to')->textInput(['type'=>'date','class'=>"form-control to_date_val"])->label(false) ?>
                                                </div>
                                            </div>
                                            <?php }?>
                    <div class="col-md-12 dj-btn-align djsec-text-right">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                    </div>
                    </div>
                </form>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                // 'pager' => [
                //     'firstPageLabel' => 'First',
                //     'lastPageLabel'  => 'Last'
                // ],
                'columns' => [
                    
                    [
                        'label'=>'Date',
                        'footerOptions'=>['style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            return date("d/m/Y", strtotime($data->date));
                            ;
                        },
                    ],
                    [
                        'label'=>'Vch No',
                        'footerOptions'=>['style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            if($data->data_from=='Debit note')
                            {
                                return 'D-'.$data->bill_id;
                            }else{
                                return $data->bill_id;
                            }
                            
                        },
                    ],
                    [
                        'label'=>'Particulars',
                        'footerOptions'=>['style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            $vendor=Vendor::find()->where(['id'=> $data->vendor_id])->one();
                            return $vendor->business_name;
                        },
                        'footer'=>'Grand Total'

                    ],
                    [
                        'label'=>'vendor Bill No',
                        'footerOptions'=>['style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            return $data->vendor_bill_no;
                        },
                    ],
                    [
                        'label'=>'Receiver GST No',
                        'footerOptions'=>['style'=>'background-color:#BCE774','class'=>'text-wrap'],
                        'value'=>function($data){
                            return $data->sender_gst_id;
                        },

                    ],
                    [
                        'label'=>'Product',
                        'footerOptions'=>['style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            $product=Product::find()->where(['id'=>$data->product_id])->one();
                            return $product->product_name;
                        },

                    ],
                    [
                        'label'=>'HSN/SAC Code',
                        'footerOptions'=>['style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            return $data->hsn_sac_code;
                        },

                    ],
                    [
                    'label'=>'Qty',
                    'footerOptions'=>['style'=>'background-color:#BCE774'],
                    'value'=>function($data){
                        return $data->qty;
                    },
                    'footer' => $qty


                    ],
                    [
                        'label'=>'Rate',
                        'contentOptions' => ['class' => 'right'],
                        'footerOptions' => ['class' => 'right','style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            return number_format((float)$data->price, 2, '.', '');
                        },
                        'footer' => Yii::$app->formatter->asCurrency($price,'INR'),
                    ],
                    [
                        'label'=>'Discount',
                        'contentOptions' => ['class' => 'right'],
                        'footerOptions' => ['class' => 'right','style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            if($data->discount_type=='%')
                            {
                                return number_format((float)($data->qty*$data->price)*($data->discount/100), 2, '.', '');
                            }else{
                                return number_format((float)$data->discount, 2, '.', '');
                            }
                        },
                        'footer' => Yii::$app->formatter->asCurrency($discount,'INR'),
                    ],
                    [
                        'label'=>'Taxable Value',
                        'contentOptions' => ['class' => 'right'],
                        'footerOptions' => ['class' => 'right','style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            if($data->discount_type=='%'){
                                $taxable_value1=($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100));
                                return number_format((float)$taxable_value1, 2, '.', '');
                            
                            }elseif ($data->discount_type=='FLAT') {
                                $taxable_value1=($data->price-$data->discount)*$data->qty;
                                return $taxable_value1;

                            }                        },
                        'footer' => Yii::$app->formatter->asCurrency($taxable_value,'INR'),

                    ],
                    [
                        'label'=>'IGST',
                        'contentOptions' => ['class' => 'right'],
                        'footerOptions' => ['class' => 'right','style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            $igst1=$data->amount-($data->price*$data->qty-$data->discount);
                            if($data->point_of_supply!=21){
                                return number_format((float)$igst1, 2, '.', '');
                            }else{
                                return '0.00';
                            }
                        },
                        'footer' => Yii::$app->formatter->asCurrency($igst,'INR'),
                    ],
                    [
                        'label'=>'CGST',
                        'contentOptions' => ['class' => 'right'],
                        'footerOptions' => ['class' => 'right','style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            $cgst1=($data->amount-(($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100))))/2;
                            if($data->point_of_supply==21){
                                return number_format((float)$cgst1, 2, '.', '');
                            }else{
                                return '0.00';
                            }                        },
                        'footer' => Yii::$app->formatter->asCurrency($sgst,'INR'),

    
                    ],
                    [
                        'label'=>'SGST',
                        'contentOptions' => ['class' => 'right'],
                        'footerOptions' => ['class' => 'right','style'=>'background-color:#BCE774'],
                        'value'=>function($data){
                            $sgst1=($data->amount-(($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100))))/2;
                            if($data->point_of_supply==21){
                                return number_format((float)$sgst1, 2, '.', '');
                            }else{
                                return '0.00';
                            } 
                        },
                        'footer' => Yii::$app->formatter->asCurrency($sgst,'INR'),
                    ],
                    

                ],
            ]); ?>            
        </div>
    </div>
</div>
    <?php ob_start();?>
<script type="text/javascript">
    $(function() {
        $('#advance-search').click(function(){
            $('#search-report').toggle();
        });
        $(".hsn").select2({
    ajax: { 
            url: "hsndetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                string: params.term // search term
                };
            },
            processResults: function (response) {
                // console.log(response);
                return {
                    results: $.map(response, function (i,item) {
                         console.log(i,item);
                    return {
                        text: i.description,
                        slug: "",
                        id: i.code
                    }
                })
            };
                    
               
            },
            cache: true
            }
});
$('.find_product').select2({
        ajax: { 
        url: '<?php echo Url::toRoute('inward-supplies-details/productdetails'); ?>',
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    $('.customer').select2({
        ajax: { 
        url: "customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            
            $('#customersearch').trigger('change');
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    $('.to_date').hide();
$('.from_date').hide();
if($('.time_frame').val()=='Custom')
	{
		$('.to_date').show();
        $('.from_date').show();
	}
	else
	{
		$('.to_date').hide();
        $('.from_date').hide();
        $('.to_date_val').val('');
        $('.from_date_val').val('');
	}
$('.time_frame').change(function()
{
	if($(this).val()=='Custom')
	{
		$('.to_date').show();
        $('.from_date').show();
	}
	else
	{
		$('.to_date').hide();
        $('.from_date').hide();
        $('.to_date_val').val(' ').trigger('change');
        $('.from_date_val').val(' ').trigger('change');
	}
})
    
    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
