<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use backend\modules\master\models\Product;
use backend\modules\master\models\CallStatus;
use backend\modules\master\models\BusinessType;
use backend\modules\master\models\LeadExecutive;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\LeadsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Leads';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      /* Opera 4-6 */
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                <div class="card">
                    <div class="no-gutters row">
                        <div class="col-md-12 col-lg-12">
                            <ul class="list-group list-group-flush">
                                <li class="bg-transparent list-group-item">
                                    <div class="widget-content p-0">
                                        <div class="widget-content-outer">
                                            <div class="widget-content-wrapper">
                                                <div class="widget-content-left">
                                                    <div class="widget-numbers dj-text-success">All Leads Report</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </li>
                                
                            </ul>
                        </div>
                        
                    </div>
                </div>
            </div>
            <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['method' => 'get','options' => []]); ?>
						   <div class="row dj-adv-search-row">
						   <div class="col-md-4">
                               <div class="position-relative form-group" >
                               <?= $form->field($model, 'search')->textInput(['maxlength' => true,'class'=>"form-control",'placeholder'=>"Name/Organisation/company"])->label(false) ?>
                              </div>
                            </div>
                            <!-- Name/ Company/ Email/ Mobile/ City/ Subject/ Content -->
							<div class="col-md-2">
                            <button class="search_field_buttons" style="background: #0a94c4;"><i class="fa fa-search"></i> Search</button>

								<!-- <a href="#" class="btn btn-rounded dj-adv-search"><i class="fa fa-search"></i> Search</a> -->
							</div>
                            <?php ActiveForm::end(); ?>
							<div class="col-md-3">
							<a id="advance-search" class="search_field_buttons"style="background: #0a94c4;" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            
							</div>
                            <div class="col-md-1">
                            <a class="search_field_buttons" style="background: #0a94c4;" href="<?=Url::base().'/reports/leads-report/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type='button' title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true" ></i></a>
                            </div>
                            <div class="col-md-2">
                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                    <a href="<?= Url::current() ?>&excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } else { ?>
                                                    <a href="<?= Url::current() ?>?excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } ?>

                            </div>
						   </div>
									<!-- <form class="dj-sale-form collapse" id="search-look"> -->
                                    <?php $form = ActiveForm::begin(['method' => 'get','options' => ['class'=>"dj-sale-form collapse",'id' => 'search-look']]); ?>

                                        <div class="form-row" id="advance-details">
										<!-- <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Date Type</label>
                                                     <select class="lead_date form-control">
														<option value="1">Lead Date</option>
                                                    </select>
                                                </div>
												
                                            </div> -->
										<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Enquiry No</label>
                                                    <?= $form->field($model, 'enq_no')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Business Types</label>
                                                    <?php $business_type=ArrayHelper::map(BusinessType::find()->all(),'business_type_name','business_type_name');
                                                        echo $form->field($model, 'bus_type')->dropDownList($business_type,['prompt'=>'--Select--','class'=>'form-control business_type'])->label(false);
                                                        ?>
                                                </div>
												
                                            </div>
											<!-- <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Lead Type</label>
                                                    <?= $form->field($model, 'lead_type')->dropdownList([
                                                                'new' => 'new', 
                                                                'postponed' => 'postponed',
                                                            ],
                                                            ['prompt'=>'--Select--','class'=>'form-control lead_type']
                                                        )->label(false) ?>
                                                </div>
												
                                            </div> -->
											
                                            <!-- <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">User</label>
                                                    <?//php $user=ArrayHelper::map(User::find()->all(),'id','username');
                                                        //echo $form->field($model, 'userid')->dropDownList($user,['prompt'=>'--Select--','class'=>'form-control userid'])->label(false);
                                                        ?>
                                                </div>
                                            </div> -->
											  <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Status</label>
                                                    <?php $status=ArrayHelper::map(CallStatus::find()->all(),'call_status_name','call_status_name');
                                                    echo $form->field($model, 'st')->dropDownList($status,['prompt'=>'--Select--','class'=>'form-control call_status_name'])->label(false);
                                                    ?>
                                                </div>
                                            </div>
											 
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">City</label>
                                                    <?= $form->field($model, 'ct')->dropdownList([
                                                                'Bhubaneswar' => 'Bhubaneswar', 
                                                                'Chennai' => 'Chennai',
                                                                'Cuttack' => 'Cuttack',
                                                            ],
                                                            ['prompt'=>'--Select--','class'=>'city form-control']
                                                        )->label(false) ?>
                                                </div>
                                            </div>
											 <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Executive</label>
                                                    <?php $lead_exe=ArrayHelper::map(LeadExecutive::find()->all(),'name','name');
                                                    echo $form->field($model, 'exe')->dropDownList($lead_exe,['prompt'=>'--Select--','class'=>'form-control lead_executive'])->label(false);
                                                    ?>
                                                </div>
                                            </div>
											 <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Product</label>
                                                    <?php if($model->product!=''){?>
                                                    <?php $product=Product::find()->where(['product_name'=>$model->product])->one()?>
                                                   <?=$form->field($model, 'product')->dropDownList([$model->product=>$product->product_name], ['options' => [$model->product => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "findproduct form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                   <?= $form->field($model, 'product')->dropDownList([],['prompt'=>'--Select--','class'=>'findproduct form-control'])->label(false);?>             
                                                   <?php } ?>            
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Lead Status</label>
                                                    <?= $form->field($model, 'lead_status')->dropdownList([
                                                                'Active' => 'Active', 
                                                                'Disqualified' => 'Disqualified',
                                                            ],
                                                            ['prompt'=>'--Select--','class'=>'form-control lead_status']
                                                        )->label(false) ?>
                                                </div>
                                            </div>
											
                                            <div class="col-md-4 dj-btn-align" style="padding-top: 5px">
                                            <!-- <a href="#" class="btn btn-primary btn-rounded dj-search"><i class="fa fa-search"></i> -->
											<button class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search"></i> Search</button>
											</div>
                                            
                                        </div>
                                        <?php ActiveForm::end(); ?> 
                                    
                                </div>
                        </div>
                <div class="main-card mb-3 card">
            <div class="card-body">
            <div class="row">
           
                <!-- <div class="col-md-6">
            <div class="djsec-text-right dj-print-sec">
                                 <a href="<?=Url::base();?>/master/leads/excel-export" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                                
                            </div>
                    </div> -->
                    </div>
        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            // 'filterModel' => $searchModel,
            'columns' => [
               ['class' => 'yii\grid\CheckboxColumn'],
                
                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Enq',
                    'attribute'=>'enquiry_no',
                   'value'=> function($data){
                       return $data->enquiry_no;
                   }

                ],

                [
                    'header'=> 'Date',
                    'attribute'=>'lead_date',
               
                'value' => function ($data) {
                    if($data->lead_date!='')
                    {
                        return date('F j Y', strtotime($data->lead_date));
                    }
                    
            },
              ],
                [
                    
                    'contentOptions' => ['class' => 'text-wrap','style'=>'font-weight:bolder'],
                    'header'=> 'Name',
                    'attribute'=>'name',
                    'value'=>'name',
                ],
                [
                    'header'=> 'Product.',
                    'contentOptions' => ['class' => 'text-wrap'],
                    'attribute' => 'product_model',
                    'value'=> function($data){
                        return $data->product_model != null ? $data->product_model : '';
                    } 
                ],
                [
                    'contentOptions'=>[ 'style'=>'max-width:14px'],
                    'header'=> 'Remark',
                    'attribute'=>'remark',
                    'value'=>'remark',
                ],
                // [
                //     'header'=> 'Assigned',
                //     'headerOptions' => ['style' => 'color:#495057'],
                //     'value'=> function($data){

                //         $user= User::find()->where(['id' =>$data->userid])->one();
                //         if(isset($user))
                //         return $user->username;
                //         else return "";
                //     }                     
                // ],
                [
                    'contentOptions' => ['class' => 'text-wrap'],
                    'header'=> 'Email',
                    'format'=>'html',
                    'attribute' => 'email',
                    'value'=>'email',
                ],
                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'City',
                    'attribute' => 'city',
                    'value'=> function($data){
                        return $data->city;
                    }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Business Type',
                    'attribute' => 'business_type',
                    'value'=> function($data){
                        return $data->business_type;
                    }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Executive',
                    'attribute' => 'executive',
                    'value'=> function($data){
                        return $data->executive;
                    }

                ],

                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Postponed?',
                    // 'attribute'=>'postponed_date',
                    'value' => function ($data) {  
                        if($data->postponed_date!='')  
                        return date('F j Y', strtotime($data->postponed_date));
                },

                ],
                // [
                //     'headerOptions' => ['style' => 'color:#495057'],
                //     'header'=> 'Age',
                //     'value'=> function($data){
                //         $bday = new DateTime($data->lead_date);//dd.mm.yyyy
                //         $today = new DateTime('00:00:00'); // Current date
                //         $diff = $bday->diff($today, true);

                //         return  $diff->format('%a') . ' days';;
                //     }
                // ],
                [
                    'header'=> 'Status',
                    'attribute' => 'status',
                    'format'=>'raw',
                    'value'=>function ($data) { 
                    if($data['status'])
                    {
                        // return $data['status'];
                        if($data['status']=='hold')
                        {
                             return '<span class="label-draft">ON HOLD</span>';
                        }
                        else if($data['status']=='postponed')
                        {
                            return '<span class="label-draft">POSTPONED</span>';
                        }
                        else if ($data['status']=='OnGoing') {
                            return '<span class="label-partial">ON GOING</span>';
                        }else if ($data['status']=='Pending') {
                            return '<span class="label-draft">PENDING</span>';
                        }
                        else {
                            $status=$data['status'];
                            return "<span class='label-paid'>$status</span>";
                        }
                        
                    }
                }
                ],
                [
                'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Conv. To',
                ],
            
             ],
        ]); ?>
            </div>
        </div>
    </div>
    <?php ob_start();?>
 <script type="text/javascript">
$(function() {
$('.lead_date').select2({'width':'100%'});
$('.city').select2({'width':'100%'});
$('.lead_type').select2({'width':'100%'});
$('.product_model').select2({'width':'100%'});
$('.lead_executive').select2({'width':'100%'});
$('.call_status_name').select2({'width':'100%'});
$('.lead_status').select2({'width':'100%'});
$('.business_type').select2({'width':'100%'});
$('.userid').select2({'width':'100%'});
$('#delete').click(function(){
var ids = $('#w1').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.disqualify').click(function(){
var confirm = window.confirm("Are you sure you want to disqualify?");
if (confirm == true)
return true;
else
return false;
})
$('.postpond').click(function(){
var confirm = window.confirm("Are you sure you want to postponed?");
if (confirm == true)
return true;
else
return false;
})
$('#advance-details').hide();
$('#advance-search').click(function(){
    $('#advance-details').toggle();
})
$('.findproduct').select2({
            ajax: { 
            url: "productdetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                // console.log(response);
                return {
                    results: $.map(response, function (i,item) {
                        // console.log(i,item);
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
                    
               
            },
            cache: true
            }
            })

$('input[name="LeadsSearch[lead_date]"]').attr('type','date');
 $('input[name="LeadsSearch[lead_date]"]').attr('style','width:95px');
$('input[name="LeadsSearch[postponed_date]"]').attr('type','date');
$('input[name="LeadsSearch[postponed_date]"]').attr('style','width:95px');
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
