<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use yii\helpers\ArrayHelper;
use backend\modules\users\models\PurchaseBill;
use backend\modules\master\models\Vendor;
use backend\modules\users\models\PurchasePayment;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Outstanding Expense';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    table, th, td {
        border: 1px solid black !important;
        border-collapse: collapse !important;

    }
    th, td {
        padding: 5px !important;
        text-align: left !important;
        color:black !important;

    }
    th{
        border:none;
        background-color:slategray;
    }
</style>

<p style="text-align: center"><strong>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</strong>
    <br>
    <br>F2G/30, INDRADHANU MARKETIRC VILLAGE, <br>BHUBANESWAR
<h2 style="text-align:center">Purchase Outstanding Expense</h2>

    <h4 style="text-align: right"><?= date("d/m/Y")?></h4>
</p>
<?= GridView::widget([
    'dataProvider' => $dataProvider,
    'summary'=> '',
    'showFooter' => true,
    'footerRowOptions'=>['style'=>'font-weight:bold;'],
    'columns' => [

        [
            'label'=>'Customer',
            'visible' => $is_vendor,
            'value'=>function($data){
                return $data->vendor_category;
            }
        ],
        [
            'label'=>'Mobile No.',
            'visible' => $vendor_mobile,
            'value'=>function($data){
                if($data->vendor_category!='')
                {
                    Vendor::find()->where(['business_name'=>$data->vendor_category])->one()->mobile;
                }
            }
        ],
        [
            'label'=>'Date',
            'visible' => $bill_date,
            'value'=>function($data){
                // if($data->bill_id!='')
                // {
                    // return date('d/m/Y', strtotime(PurchaseBill::find()->where(['id'=>$data->bill_id])->one()->date));
                    return date('d/m/Y', strtotime($data->date));
                // }
            }
        ],
        [
            'label'=>'Referance Bill',
            'visible' => $bill_referance,
            'value'=>function($data){
                if($data->bill_id!='')
                {
                    return PurchaseBill::find()->where(['id'=>$data->bill_id])->one()->vendor_bill_no;
                }
            }
        ],
        [
            'label'=>'Amount',
            'visible' => $bill_amount,
            'value'=>function($data){
               if($data->bill_id!='')
               {
                    $bill = PurchaseBill::find()->where(['id'=>$data->bill_id])->one();
                    $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$bill->total);
                    return $num;
               }
               else
               {
                    $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->amount);
                    return $num;
               } 
            }
        ],
        [
            'label'=>'Paid Amount',
            'visible' => $bill_paid_amount,
            'value'=>function($data){
                if($data->bill_id!='')
                {
                    $bill = PurchaseBill::find()->where(['id'=>$data->bill_id])->one();
                    $payment = PurchasePayment::find()->where(['against_bill'=>$bill->id])->all();
                    
                    $total = 0;
                    foreach ($payment as $key => $value) {
                          $total = $total + $value->amount;
                    }
                    $total = $bill->total-($bill->pending_amount);  
                    return number_format($total,2);
                }
                else
                {
                    if($data->paid_amount!='')
                    {
                     $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->paid_amount);
                     return $num;
                    }
                    else
                      return '0.00';
                } 
            }
        ],
        [
            'label'=>'Unpaid Amount',
            'visible' => $bill_unpaid_amount,
            'value'=>function($data){
                 if($data->bill_id!='')
                {
                    

                    $bill = PurchaseBill::find()->where(['id'=>$data->bill_id])->one();
                    return $bill->pending_amount;
                }
                else
                {
                    $finalamount = number_format((float)($data->amount-$data->paid_amount), 2, '.', '');
                    $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$finalamount);
                    return $num; 
                }
            }
        ],
        [
            'label'=>'Due Date',
            'visible' => $bill_bue_date,
            'value'=>function($data){
                return date('d/m/Y', strtotime($data->due_date));
                // return $data->due_date;
            }
        ],
        [
            'label'=>'Due days',
            'visible' => $bill_days,
            'value'=>function($data){
                if($data->due_date!='')
                {
                    $today= time();
                    $date = strtotime($data->due_date);
                    $diff= $date-$today;
                    $age = floor($diff/(60*60*24)).' Days';
                    if($age<0)
                     {
                        $final_age = -1 * (int)$age ;
                        return (int) $final_age;
                     }
                    else
                        return '0';
                }
                else
                    return '0'; 
            },
            

        ],
        [
            'label'=>'Notes',
            'visible' => $bill_notes,
            'value'=>function($data){
                if($data->bill_id!='')
                {
                    return PurchaseBill::find()->where(['id'=>$data->bill_id])->one()->notes;
                }
            }
        ],
        [
            'label'=>'Terms',
            'visible' => $bill_terms,
            'value'=>function($data){
                if($data->bill_id!='')
                {
                    return PurchaseBill::find()->where(['id'=>$data->bill_id])->one()->terms;
                }
            }
        ],
        [
            'label'=>'Current Ourstanding',
            'visible' => $bill_current_outstanding,
            'value'=>function($data){
                return "0.00";
            }
        ],
        [
            'label'=>'Current Ourstanding',
            'visible' => $bill_current_outstanding,
            'value'=>function($data){
                return "0.00";
            }
        ],
        [
            'label'=>'Over Due',
            'visible' => $bill_over_due,
            'value'=>function($data){
               if($data->bill_id!='')
                {
                    

                    $bill = PurchaseBill::find()->where(['id'=>$data->bill_id])->one();
                    return $bill->pending_amount;
                }
                else
                {
                    $finalamount = number_format((float)($data->amount-$data->paid_amount), 2, '.', '');
                    $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$finalamount);
                    return $num; 
                }
            }
        ],
        [
            'label'=>'Total Ourstanding',
            'visible' => $bill_total_outstanding,
            'value'=>function($data){
                if($data->bill_id!='')
                {
                    

                    $bill = PurchaseBill::find()->where(['id'=>$data->bill_id])->one();
                    return $bill->pending_amount;
                }
                else
                {
                    $finalamount = number_format((float)($data->amount-$data->paid_amount), 2, '.', '');
                    $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$finalamount);
                    return $num; 
                }
            }
        ],

    ],

]); ?>


</div>
</div>
</div>
